Junk Files
----------

The repository should contain the `.cpp` and `.h` files
and the `Makfile` in the `src` directory. Pretty much
all other files are junk, and should not be added and
committed to the repository. It's ok if you keep them
in your working directory.

To see all files in the directory, you can do:

    ls -la
    
You can check what has been added to the repository
and pushed to the cloud through the web interface to
the github repository.

Remove any file that is in the cloud, but should not be.

    git rm the_unwanted_file_name
    
Make sure git won't add it in the future by adding to 
the `.gitignore` file at the root of the repository.
Entries here are usually file name patterns, but
occasionally actual file names. For example,
to have git ignore all object files, we would add:

    *.o

That entry is already there, so you don't need to
add it. However, the `inquisitor` program from 
the practice exam1 would probably be mentioned by
name:

    inquisitor

After you are done editing, add the changes:

    git add .gitignore
    
Commit and push:

    git commit -m 'removed files xyz from repository'
    git push
    
In the future, only `git add` specific files that you
know need to be part of the repository. Don't go adding
*everything*, you'll just make more work for yourself 
in the future.


Here are some additional notes on specific file types
that frequently start showing up in repositories, but
should not.


Compiled Files
--------------


*.gch
--------

Created by mistakenly by compiling .h files.
Added to repository by forcing inclusion,
contrary to the .gitignore instructions.

To stop creating them: be sure that compile
commands only include the .cpp file, and
not .h files.  

`Makefile` rules should look like this:

    fred.o: fred.cpp fred.h barney.h
        g++ -std=c++11 -c fred.cpp
    
To remove from repository:

    git rm *.gch
    git commit -m 'remove compiled header files'
    git push

*.o
--------

These files should already be ignored, and should not
be forcibly added to the repository. They are fine
to leave in your working directory.

program_files
-------------

Program files, such as `hello` or `ascii_image`
should already be ignore, because I added them to
the `.gitignore` before you cloned your repository.

Be careful to keep adding other program files to
the `.gitignore`, especially those created during
exam tasks. Be careful not to `git add` them
blindly.
    
    
Editor Droppings
----------------

*:Zone.Identifier
-----------------

Remove from the repository. These are not
source code.

    git rm *:Zone.Identifier

Prevent them from being added to the repository in
the future by adding a line to `.gitignore` that says:

    *:Zone.Identifier

Then add the change:

    git add .gitignore
    
Finally commit the changes:

    git commit -m 'remove Zone.Identifier from repository'
    
In the future, only do `git add` on specific files, not
on all files in a directory.


    
.*.sw?
---------------------------

Remove from the repository. These are not
source code.

    git rm .*.sw?

Prevent them from being added to the repository in
the future by adding a line to `.gitignore` that says:

    .*.sw?

Then add the change:

    git add .gitignore
    
Finally commit the changes:

    git commit -m 'remove VIM droppings from repository'
    
In the future, only do `git add` on specific files, not
on all files in a directory.


