#include <iostream>
#include <vector>

// pass by value (copy)
void fail_change_int_value(int a) {
  a = 19;
}

// pass by pointer (copy address)
void change_int_value(int *iptr) {
  *iptr = 17;
}

// pass by reference (variable is at the same location)
void succeed_change_int_value(int& a) {
  a = 21;
  std::cout << "address of a: " << &a << std::endl;
}

/*void process_nums(int nums[]) {
  }*/
void process_nums(int *nums) {
}

void pass_by_copy(std::vector<int> scores) {
  unsigned int j;
  for(j = 0; j < scores.size(); j++) {
    scores[j] = (100-j)*(100-j);
  }
  std::cout << "pass_by_copy: " << scores[10] << std::endl;
}

void pass_by_reference(std::vector<int>& scores) {
  unsigned int j;
  for(j = 0; j < scores.size(); j++) {
    scores[j] = j*j;
  }
  std::cout << "pass_by_reference: " << scores[10] << std::endl;
}

int main() {
  int x;
  int *ptr;
  int nums[10];
  std::vector<int> scores(100);
  int i;
  for(i = 0; i < 100; i++) {
    scores[i] = i;
  }

  pass_by_copy(scores);
  std::cout << "main: " << scores[10] << std::endl;
  pass_by_reference(scores);
  std::cout << "main: " << scores[10] << std::endl;
  x = 1;
  ptr = &x;
  x = 2;
  *ptr = 3;

  change_int_value(ptr);
  fail_change_int_value(x);
  succeed_change_int_value(x);
  std::cout << "address of x: " << &x << std::endl;
  process_nums(nums);
  

  
  std::cout << "*ptr" << *ptr << std::endl;
  std::cout << "x: " << x << std::endl;

  return 0;
}
