#include "Colors.h"

ColorRGB::ColorRGB()
  : mRed(255), mGreen(255), mBlue(255) {
}

ColorRGB::ColorRGB(int r, int g, int b)
  : mRed(r), mGreen(g), mBlue(b) {
}

ColorRGB ColorRGB::operator+(const ColorRGB& rhs) const {
  ColorRGB result(mRed,mGreen,mBlue);
  result += rhs;
  return result;
}

ColorRGB& ColorRGB::operator+=(const ColorRGB& rhs) /*NO const*/ {
  int r = mRed + rhs.mRed;
  if(r > 255) {
    r = 255;
  }
  int g = mGreen + rhs.mGreen;
  if(g > 255) {
    g = 255;
  }
  int b = mBlue + rhs.mBlue;
  if(b > 255) {
    b = 255;
  }
  mRed = r;
  mGreen = g;
  mBlue = b;

  return *this;
}

ColorRGB ColorRGB::operator+(const int& rhs) const {
  ColorRGB result(mRed,mGreen,mBlue);
  result += rhs;
  return result;
}

ColorRGB& ColorRGB::operator+=(const int& rhs) /*NO const*/ {
  ColorRGB rhs_color(rhs,rhs,rhs);
  *this += rhs_color;
  return *this;
}

int ColorRGB::getRed() const {
  return mRed;
}

int ColorRGB::getGreen() const {
  return mGreen;
}

int ColorRGB::getBlue() const {
  return mBlue;
}


ColorRGB operator+(const int& lhs, const ColorRGB& rhs) {
  return rhs + lhs;
  // ColorRGB result(rhs.getRed(),rhs.getGreen(),rhs.getBlue());
  // result += lhs;
  // return result;
}

int& operator+=(int& lhs, const ColorRGB& rhs) {
  lhs += (rhs.getRed() + rhs.getGreen() + rhs.getBlue())/3;
  return lhs;
}

std::ostream& operator<<(std::ostream& os, const ColorRGB& rhs) {
  os << rhs.getRed() << "," << rhs.getGreen() << "," << rhs.getBlue();
  return os;
}
