#include "prime_functions.h"
#include <vector>
#include <iostream>
#include <sstream>
#include <chrono>

int main(int argc, char **argv) {
  // check every number and collect the prime numbers
  int N = 1;
  if(argc > 1) {
    // argv[1] is the argument

    // turn the string into a stream
    std::stringstream ss;
    ss.str(argv[1]);

    // read from the stream
    ss >> N;
  }

  std::vector<int> found_primes;
  int n;
  std::chrono::steady_clock::time_point t0 = std::chrono::steady_clock::now();
  for(n = 0; n <= N; n++) {
    if(is_prime(n)) {
      // collect it
      found_primes.push_back(n);
    }
  }
  std::chrono::steady_clock::time_point t1 = std::chrono::steady_clock::now();
  std::chrono::duration<double> dt = std::chrono::duration_cast<std::chrono::duration<double>>(t1-t0);

  // show all collected numbers
  /*
  std::vector<int>::const_iterator it;
  for(it = found_primes.begin(); it != found_primes.end(); it++) {
    std::cout << *it << " is prime." << std::endl;
  }
  */
  std::cout << found_primes.size() << " primes found from 0 to " << N << ", in " << dt.count() << " seconds." << std::endl;

  return 0;
}
