#include "prime_functions.h"
#include <vector>
#include <iostream>
#include <sstream>
#include <chrono>
#include <thread>


void prime_counter_worker(const int& first, const int& last, int& count) {
  int n;
  for(n = first; n < last; n++) {
    if(is_prime(n)) {
      // collect it
      count++;
    }
  }
}

int main(int argc, char **argv) {
  // check every number and collect the prime numbers
  int N = 1;
  if(argc > 1) {
    // argv[1] is the argument

    // turn the string into a stream
    std::stringstream ss;
    ss.str(argv[1]);

    // read from the stream
    ss >> N;
  }

  std::vector<int> found_primes;
  int count1 = 0;
  int count2 = 0;
  std::chrono::steady_clock::time_point t0 = std::chrono::steady_clock::now();
  std::vector<std::thread> threads;
  threads.push_back( std::thread(prime_counter_worker, 0, N/2, std::ref(count1)) );
  threads.push_back( std::thread(prime_counter_worker, N/2, N+1, std::ref(count2)) );
  //prime_counter_worker(0, N/2, count1);
  //prime_counter_worker(N/2, N+1, count2);

  threads[1].join();
  threads[0].join();

  std::chrono::steady_clock::time_point t1 = std::chrono::steady_clock::now();
  std::chrono::duration<double> dt = std::chrono::duration_cast<std::chrono::duration<double>>(t1-t0);

  std::cout << (count1 + count2) << " primes found from 0 to " << N << ", in " << dt.count() << " seconds." << std::endl;

  return 0;
}
