#include "PrimeCounter.h"
#include <sstream>
#include <chrono>
#include <iostream>
#include <thread>

int main(int argc, char **argv) {
  // check every number and collect the prime numbers
  int N = 1;
  int thread_count = -1;
  if(argc > 1) {
    // argv[1] is the argument

    // turn the string into a stream
    std::stringstream ss;
    ss.str(argv[1]);

    // read from the stream
    ss >> N;
  }
  if(argc > 2) {
    // argv[2] is the argument

    // turn the string into a stream
    std::stringstream ss;
    ss.str(argv[2]);

    // read from the stream
    ss >> thread_count;
  }
  if(thread_count <= 0) {
    thread_count = (int)std::thread::hardware_concurrency();
  }

  std::chrono::steady_clock::time_point t0 = std::chrono::steady_clock::now();

  PrimeCounter prime_counter;
  prime_counter.fill_tasks(N);
  prime_counter.process_all_tasks(thread_count);

  std::chrono::steady_clock::time_point t1 = std::chrono::steady_clock::now();
  std::chrono::duration<double> dt = std::chrono::duration_cast<std::chrono::duration<double>>(t1-t0);

  std::cout << prime_counter.getCount() << " primes found from 0 to " << N << ", in " << dt.count() << " seconds." << std::endl;

  
  return 0;
}
