#include "factorial_functions.h"

bigint factorial(bigint n) {
  bigint f;
  if(n <= 1) {
    f = 1;
  } else {
    f = n * factorial(n-1);
  }
  return f;
}

bigint fib(bigint n) {
  bigint f;
  if(n <= 2) {
    f = 1;
  } else {
    f = fib(n-1) + fib(n-2);
  }
  return f;
}

bigint fib_memo(bigint n, std::vector<bigint>& memo) {
  bigint f;
  if(memo[n-1] != 0) {
    f = memo[n-1];
  } else if(n <= 2) {
    f = 1;
  } else {
    f = fib_memo(n-1, memo) + fib_memo(n-2, memo);
  }
  memo[n-1] = f;
  return f;
}
