#include "Weather.h"
#include <iostream>
#include <iomanip>

int main( ) {
  Weather w( 7, 11 ); // small weather grid
  Weather v;   // demo of creating a default sized weather grid

  // set some temperatures;
  int row, column;
  for( row = 0; row < w.getHeight( ); row ++ ) {
    for( column = 0; column < w.getWidth( ); column ++ ) {
      // 0 means temperature
      w.setValue( row, column, 0, row * 0.1 + column * 1.0 );
    }
  }

  // set some wind speeds;
  for( row = 0; row < w.getHeight( ); row ++ ) {
    for( column = 0; column < w.getWidth( ); column ++ ) {
      // 1 means wind speed
      w.setValue( row, column, 1, row * -0.1 + column * 1.0 );
    }
  }

  // display the temperature grid
  std::cout << "Temperature Grid: " << std::endl;
  std::cout << "==================" << std::endl;
  for( row = 0; row < w.getHeight( ); row ++ ) {
    std::cout << row << " ";
    for( column = 0; column < w.getWidth( ); column ++ ) {
      double v = w.getValue( row, column, 0 );
      std::cout << std::fixed << std::setprecision( 1 ) << std::setw( 4 ) ;
      std::cout << v << " ";
    }
    std::cout << std::endl;
  }

  std::cout << std::endl;

  // display the wind speed grid
  std::cout << "Wind Speed Grid: " << std::endl;
  std::cout << "==================" << std::endl;
  for( row = 0; row < w.getHeight( ); row ++ ) {
    std::cout << row << " ";
    for( column = 0; column < w.getWidth( ); column ++ ) {
      double v = w.getValue( row, column, 1 );
      std::cout << std::fixed << std::setprecision( 1 ) << std::setw( 4 ) ;
      std::cout << v << " ";
    }
    std::cout << std::endl;
  }

  return 0;
}
