#include <fstream>
#include <iostream>
#include <vector>

void read_binary_data( std::istream& is, std::vector< unsigned char >& data ) {
  unsigned char newline_junk;
  unsigned char c;
  int n, i;
  is >> n; // read the number of bytes in the data section of the file
  is.read((char*)&newline_junk, 1); // skip the newline character
  for( i = 0; i < n; i++ ) { // read the binary data
    is.read( ( char * ) &c, 1 );
    data.push_back( c );
  }
  
}

void write_binary_data( std::ostream& os ) { 
  unsigned char c;
  int n = 254;
  os << n << "\n";  // write the number of bytes in the data section, followed by a newline
  for( c = 0; c < 255; c++ ) { // write the binary data
    os.write( ( char * ) &c, 1 );
  }
}

int main( ) {

  // create a data file with an ASCII text header line, followed by binary data
  std::ofstream fout( "binary-out.dat" );
  write_binary_data( fout );
  fout.close( );
  
  // read a data file with an ASCII text header line, followed by binary data
  std::vector< unsigned char > data;
  std::ifstream fin( "binary-out.dat" );
  read_binary_data( fin, data );
  fin.close( );

  // Display the data read from the file
  size_t i;
  for( i = 0; i < data.size( ); i++ ) {
    std::cout << i << " " << static_cast< int >( data[ i ] ) << std::endl;
  }

  return 0;
}
