#include "Complex.h"

Complex::Complex()
  : mReal(0.0), mImag(0.0) {
  // empty
}

Complex::Complex(const double& real, const double& imag)
  : mReal(real), mImag(imag) {
  // empty
}

double Complex::getReal() const {
  return mReal;
}

double Complex::getImag() const {
  return mImag;
}

Complex Complex::add(const Complex& rhs) const {
  double real = mReal + rhs.mReal;
  double imag = mImag + rhs.mImag;
  Complex result(real, imag);
  return result;
}

Complex Complex::operator+(const Complex& rhs) const {
  double real = mReal + rhs.mReal;
  double imag = mImag + rhs.mImag;
  Complex result(real, imag);
  return result;
}

Complex& Complex::operator+=(const Complex& rhs) {
  mReal += rhs.mReal;
  mImag += rhs.mImag;
  return *this;
}

Complex Complex::operator*(const Complex& rhs) const {
  double real = mReal * rhs.mReal - mImag * rhs.mImag;
  double imag = mReal * rhs.mImag + mImag * rhs.mReal;
  
  Complex result(real, imag);
  return result;
}

bool Complex::operator==(const Complex& rhs) const {
  // if(mReal == rhs.mReal && mImag == rhs.mImag) {
  //   return true;
  // } else {
  //   return false;
  // }
  return mReal == rhs.mReal && mImag == rhs.mImag;
}
