#ifndef _COMPLEX_H_
#define _COMPLEX_H_

class Complex {
public:
  Complex();
  Complex(const double& real, const double& imag);

  double getReal() const;
  double getImag() const;
  //          VVVVV protects rhs  VVVVV protects the lhs (this)
  Complex add(const Complex& rhs) const;
  Complex operator+(const Complex& rhs) const;
  Complex& operator+=(const Complex& rhs);
  Complex operator*(const Complex& rhs) const;

  bool operator==(const Complex& rhs) const;

private:
  double mReal;
  double mImag;
};

#endif /* _COMPLEX_H_ */
/* Local Variables: */
/* mode:c++         */
/* End:             */
