#include <vector>
#include <iostream>

class MyContainer {
  // Stores 3 numbers, makes them accessible via indexing
public:
  // Why are there two operator[]?
  double& operator[](int i);
  const double& operator[](int i) const;

private:
  double mA;
  double mB;
  double mC;
};

double& MyContainer::operator[](int i) {
  if(i == 0) {
    return mA;
  } else if(i == 1) {
    return mB;
  } else if(i == 2) {
    return mC;
  } else {
    static double backup_error = -1.0;
    static double error = -1.0;
    error = backup_error;
    return error;
  }
}

const double& MyContainer::operator[](int i) const {
  if(i == 0) {
    return mA;
  } else if(i == 1) {
    return mB;
  } else if(i == 2) {
    return mC;
  } else {
    static double backup_error = -1.0;
    static double error = -1.0;
    error = backup_error;
    return error;
  }
}

void display(const MyContainer& numbers) {
  // What happens if we uncomment this line?
  // numbers[0] = 2.71;
  int i;
  for(i = -1; i < 4; i++) {
    std::cout << i << " " << numbers[i] << std::endl;
  }
}

void set_values(MyContainer& numbers) {
  numbers[0] = 3.14;
  numbers[1] = 7.3;
  numbers[2] = numbers[0] + numbers[1];

}

int main() {
  MyContainer numbers; // stores 3 numbers

  set_values(numbers);
  display(numbers);

  // What happens with index out of range?
  numbers[3] = 3.14;
  std::cout << numbers[3] << std::endl;
  
  numbers[-10000] = 1.234;
  std::cout << numbers[-10000] << std::endl;
  
  return 0;
}
