#include "prime_functions.h"
#include <iostream>
#include <sstream>
#include <thread>
#include <functional>
#include <vector>
#include <mutex>

int main(int argc, char *argv[]) {
  int n = 12;
  if(argc >= 2) {
    std::stringstream ss(argv[1]);
    ss >> n;
  }

  int c1, c2;

  std::vector<int> tasks(n-1);
  std::mutex lock;
  int i;
  for(i = 2; i <= n; i++) {
    tasks[i-2] = i;
  }
  
  std::thread t1(count_primes_in_tasks, std::ref(tasks), std::ref(lock), std::ref(c1));
  std::thread t2(count_primes_in_tasks, std::ref(tasks), std::ref(lock), std::ref(c2));

  t1.join();
  t2.join();

  int count = c1 + c2;

  std::cout << "There are " << count << " primes in the range [2, " << n << "]." << std::endl;
  return 0;
}

